-- Author      : Gudvinus
local EVENT, DB = {},{};
local l,tempID;

local After							= C_Timer.After;
local ApplyToGroup					= C_LFGList.ApplyToGroup;
local GetApplicationInfo			= C_LFGList.GetApplicationInfo;
local GetAvailableRoles				= C_LFGList.GetAvailableRoles;
local GetSearchResultInfo			= C_LFGList.GetSearchResultInfo;
local GetSearchResults				= C_LFGList.GetSearchResults;
local IsInGroup						= IsInGroup;
local IsQuestFlaggedCompleted		= IsQuestFlaggedCompleted;
local LFGListInviteDialog_Accept	= LFGListInviteDialog_Accept;
local find							= find;
local lower							= string.lower;
local pairs							= pairs;
local strsplit						= strsplit;

local DP={["Toy"]={true,true,"dreadlord||dread infiltrator||dread||doomsayer||toy||игрушка||вестник","camp||farm||not up",false,3,4,false,0},["Opasik"]={true,true,"terr||doom||death||veng","camp||farm||not up",true,3,4,false,0}};


local ACHIEVEMENT_COLOR_CODE		= "|cffffff00";
local BATTLENET_COLOR	= "|cff82c5ff";
local DISABLED_FONT_COLOR_CODE	= "|cff7f7f7f";
local FONT_COLOR_CODE_CLOSE		= "|r";
local GRAY_FONT_COLOR_CODE		= "|cff808080";
local GREEN_COLOR		= "|cff20ff20";
local HIGHLIGHT_FONT_COLOR_CODE	= "|cffffffff";
local LIGHTYELLOW_FONT_COLOR_CODE	= "|cffffff9a";
local NORMAL_FONT_COLOR_CODE		= "|cffffd200";
local ORANGE_COLOR		= "|cffff7f3f";
local RED_COLOR			= "|cffff2020";
local YELLOW_COLOR		= "|cffffff00";

local L = {
	ruRU = {
		REFRESHRATE = BATTLENET_COLOR.."Частота обновления|r\nЕсли сервер вернет ошибку частота автоматически будет повышаться.",
		STRINGFIND = BATTLENET_COLOR.."Ключевые слова|r\nВводите в это поле слова или словосочетания, разделяя их символом |\n"..RED_COLOR.."Поле не может быть пустым!|r",
		STRINGEXCLUDE = BATTLENET_COLOR.."Без слов|r\nВводите в это поле слова или словосочетания, разделяя их символом |\nЕсли слово будет найдено в названии группы, то эта группа будет игнорироваться.\n"..YELLOW_COLOR.."Поле может быть пустым!|r",
		AGEMAKEGROUP = BATTLENET_COLOR.."Время с создания группы|r\nЗдесь указывается максимальное время прошедшее с момента создания группы, после которого группа будет игнорироваться.\n"..YELLOW_COLOR.."[0 Без ограничений]|r",
		AUTOINV = BATTLENET_COLOR.."Автоинвайт|r\nАвтоматически подтверждать присоединение к группе.",
		AUTOINVGROUP = BATTLENET_COLOR.."Автоинвайт|r\nИскать группы только с автоинвайтом.",
		TESTMODETOOLTIP = BATTLENET_COLOR.."Режим тестирования|r\nТестирование ключевых слов и настроек, выводит сообщения, но не присоединяется к группе.",
		MINPLAYERS = BATTLENET_COLOR.."Минимум игроков|r\nМинимальное количество игроков в группе, меньше которого группа будет игнорироваться.\n"..YELLOW_COLOR.."[0 Без ограничений]|r",
		CROSSREALMMODE = BATTLENET_COLOR.."Межсерверный режим|r\n"..YELLOW_COLOR.."В связи с изменениями механики переходов, этот режим пока не эффективен!!!",
		NOKEYWORD = "Статус: "..RED_COLOR.."Нет ключевых слов!|r",
		FINDSTOP = "Статус: "..RED_COLOR.."Поиск группы остановлен.|r",
		GROUPCOUNT = "Кол-во групп в поиске: %s",
		SEARCH = "Статус: "..GREEN_COLOR.." %s |r",
		INGROUP = "Статус: "..RED_COLOR.."Вы в группе, поиск остановлен!|r",
		ONLYAUTOINV = "Автоинвайт.",
		TESTMODE = "Тестовый режим.",
		ACCEPTINV = "Принимать приглашения.",
		CROSSREALM = "Кроссервер.",
		PROFILE = "Профили\n"..GREEN_COLOR,
		PROFILELOADED = ORANGE_COLOR.."SGF: ПроФиль:|r %s "..ORANGE_COLOR.."загружен.|r",
		PROFILESAVE = ORANGE_COLOR.."SGF: ПроФиль:|r %s "..ORANGE_COLOR.."сохранен.|r",
		PROFILEDELETE = ORANGE_COLOR.."SGF: ПроФиль:|r %s "..ORANGE_COLOR.."удален.|r",
		PROFILELOAD = "Загрузить",
		GUDSFGBUTTONTOOLTIP = BATTLENET_COLOR.."Левый клик:|r старт/стоп поиск.\n"..BATTLENET_COLOR.."Правый клик:|r показать/скрыть главное окно.\n"..BATTLENET_COLOR.."Средний клик:|r управление профилями.\n"..BATTLENET_COLOR.."Shift+Левый клик:|r перемещение кнопки.",
		HELPTOOLTIP = BATTLENET_COLOR.."Помощь|r\nShift+Левый клик по окну:|r перемещение окна.\nЛевый клик: Включить/Выключить подсказки.",
		WARNDELPROFILE = RED_COLOR.."Чтобы удалить профиль удерживайте клавишу Shift!",
	},
	enGB = {
		REFRESHRATE = BATTLENET_COLOR.."Refresh Rate|r\nIf the server returns an error, the frequency will be increased automatically.",
		STRINGFIND = BATTLENET_COLOR.."Keywords|r\nEnter into this field the words or phrases, separated by the symbol |\n"..RED_COLOR.."The field can not be empty!|r",
		STRINGEXCLUDE = BATTLENET_COLOR.."Without words|r\nEnter into this field the words or phrases, separated by the symbol |\nIf the word is found in the name of the group, this group will be ignored.\n"..BATTLENET_COLOR.."The field can be left blank!|r",
		AGEMAKEGROUP = BATTLENET_COLOR.."Time of creation of the group.|r\nThis specifies the maximum amount of time elapsed since the establishment of the group, after which the group will be ignored.\n"..YELLOW_COLOR.."[0 No limits]|r",
		AUTOINV = "Automatically confirm the invite to the group.",
		AUTOINVGROUP = "Search for groups only with an automatic invitation.",
		TESTMODETOOLTIP = BATTLENET_COLOR.."Test mode|r\nTesting keywords and settings, displays the message, but did not join the group.",
		MINPLAYERS = BATTLENET_COLOR.."Minimum players|r\nMinimum number of players in the group, below which the group will be ignored.\n"..YELLOW_COLOR.."[0 No limits]|r",
		CROSSREALMMODE = BATTLENET_COLOR.."Cross-server mode|r\n"..YELLOW_COLOR.."In connection with the mechanics of the transition changes, this mode is not effective !!!",
		NOKEYWORD = "Status: "..RED_COLOR.."No keyword!|r",
		FINDSTOP = "Status: "..RED_COLOR.."Groups Search stopped.|r",
		GROUPCOUNT = "Number of groups in search: %s",
		SEARCH = "Status: "..GREEN_COLOR.." %s |r",
		INGROUP = "Status: "..RED_COLOR.."You are in a group, the search is stopped!|r",
		ONLYAUTOINV = "AutoInvite.",
		TESTMODE = "TestMode.",
		ACCEPTINV = "To accept the invitation.",
		CROSSREALM = "CrossServer.",
		PROFILE = "Profiles\n"..GREEN_COLOR,
		PROFILELOADED = ORANGE_COLOR.."SGF: Profile:|r %s "..ORANGE_COLOR.."loaded.|r",
		PROFILESAVE = ORANGE_COLOR.."SGF: Save Profile:|r %s",
		PROFILEDELETE = ORANGE_COLOR.."SGF: Delete Profile:|r %s",
		PROFILELOAD = "Load",
		GUDSFGBUTTONTOOLTIP = BATTLENET_COLOR.."Left click:|r Start/Stop search.\n"..BATTLENET_COLOR.."Right click:|r show/hide main window.\n"..BATTLENET_COLOR.."Middle click:|r manage profiles.\n"..BATTLENET_COLOR.."Shift + Left Click:|r movement buttons.",
		HELPTOOLTIP = BATTLENET_COLOR.."Help|r\nShift+Left click on a window:|r move the window.\nLeft click: Activate/Deactivate tips.",
		WARNDELPROFILE = RED_COLOR.."To delete a profile, hold the Shift key!",
	},
};

function GudSmartLFG_OnLoad(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("VARIABLES_LOADED");
	self:SetScript("OnEvent",function(self,event,...) EVENT[event](self,...); end);
end

local function LFG_FIND_RESULT(self,text)
	local text = lower(text);
	local pattern = {strsplit("|",lower(DB.Pattern))};

	for _,str in pairs(pattern) do
		if (str ~= "" and text:find(str)) then
			local exit = false;
			if DB.PatternNo ~= "" then
				local patternno = {strsplit("|",lower(DB.PatternNo))};
				for _,exclude in pairs(patternno) do
					if (exclude ~= "" and text:find(exclude)) then
						exit = true;
					end
				end
			end
			if not exit then
				return true;
			end
		end
	end
	return;
end

local BL = {};

local function IsWorks(self)
	if DB.Pattern == "" then
		self.run = false;
		self.Log:SetText(l.NOKEYWORD);
		return;
	end
	if IsInGroup() and not UnitIsGroupLeader("player") then
		self.run = false;
		self.Log:SetText(l.INGROUP);
		return;
	end
	if not self.run then
		self.Log:SetText(l.FINDSTOP);
		return;
	end
	return true;
end

local function ApplyGroup(self,id)
	PlaySoundKitID(51324);
	if not DB.TestMode then
		local tank,heal,dd = GetAvailableRoles();
		if (tank and DB.RoleTank) or (heal and DB.RoleHealer) or (dd and DB.RoleDPS) then
			ApplyToGroup(id,"",tank and DB.RoleTank,heal and DB.RoleHealer,dd and DB.RoleDPS);
		else
			ApplyToGroup(id,"",tank,heal,dd);
		end
	end
	tempID = id;
	self.run = false;
end

local function RESULTSCHECK(self,resultID)
	local id,appStatus,pendingStatus,appDuration,role = GetApplicationInfo(resultID);
	if ((appStatus ~= "none") or pendingStatus) then return; end
	local id,activityID,name,comment,voiceChat,iLvl,honorLevel,age,numBNetFriends,numCharFriends,numGuildMates,isDelisted,leaderName,numMembers,autoInv = GetSearchResultInfo(resultID);
	local fullName, shortName, categoryID, groupID, iLevel, filters, minLevel, maxPlayers, displayType, orderIndex, useHonorLevel = C_LFGList.GetActivityInfo(activityID);
	
	if isDelisted or (not age) or (not name) or (not leaderName) or (not numMembers or (numMembers ~= 0 and numMembers < DB.MinPlayers)) or (numMembers > 35) or (DB.AutoInvGroup and (not autoInv)) then return; end
	
	if not leaderName or BL[leaderName] then return; end
	
	if DB.CrossRealmMode then
		self.GroupCount:SetFormattedText(ORANGE_COLOR..""..LFG_LIST_APPLYING_TO, name);
		print(format(ORANGE_COLOR.."SGF: "..LFG_LIST_APPLYING_TO, name));
		BL[leaderName] = id;
		ApplyGroup(self,id);
		return true;
	end
	
	if LFG_FIND_RESULT(self,name) and (age < DB.TimeAge or DB.TimeAge == 0) then
		self.GroupCount:SetFormattedText(ORANGE_COLOR..""..LFG_LIST_APPLYING_TO, name);
		print(format(ORANGE_COLOR.."SGF: "..LFG_LIST_APPLYING_TO, name));
		print(format(ORANGE_COLOR.."SGF: "..LFG_LIST_TOOLTIP_AGE, SecondsToTime(age)));
		BL[leaderName] = id;
		ApplyGroup(self,id);
		return true;
	end
end

local function SGFNewSearch(self,pause)
	self.pTime = GetTime() + DB.Throttled + 2;
	if (not pause) then
		local languages = C_LFGList.GetLanguageSearchFilter();
		C_LFGList.Search(6,"",nil,nil,languages);
	else
		After(DB.Throttled,function()
			local languages = C_LFGList.GetLanguageSearchFilter();	-- {deDE = true,enUS = true,esES = true,frFR = true,ruRU = true,itIT = true,ptBR = true};
			C_LFGList.Search(6,"",nil,nil,languages);
		end);
	end
end

function EVENT.LFG_LIST_SEARCH_RESULTS_RECEIVED(self)
	if not IsWorks(self) then return; end
	local numResults,resultIDTable = GetSearchResults();
	self.GroupCount:SetFormattedText(l.GROUPCOUNT,numResults or 0);
	self.Log:SetFormattedText(l.SEARCH,FRIENDS_FRIENDS_WAITING);
	for _,resultID in pairs(resultIDTable) do
		if RESULTSCHECK(self,resultID) then return; end
	end
	SGFNewSearch(self,true);
end

function EVENT.LFG_LIST_SEARCH_RESULT_UPDATED(self,resultID)
	if not IsWorks(self) then return; end
	RESULTSCHECK(self,resultID);
end

function EVENT.LFG_LIST_SEARCH_FAILED( self, status )
	if status == "throttled" then
		DB.Throttled = DB.Throttled + 1;
		self.Throttled:SetValue(DB.Throttled);
		
		SGFNewSearch(self,true);
		print(ORANGE_COLOR.."SGF: "..LFG_LIST_SEARCH_FAILED);
	end
end

function EVENT.LFG_LIST_APPLICATION_STATUS_UPDATED( self, id, status, oldstatus )
	if id == tempID and DB.AutoInv and ( status == "invited" ) then
		LFGListInviteDialog_Accept(LFGListInviteDialog);
	end
end

function EVENT.LFG_LIST_JOINED_GROUP( self, id )
	if id == tempID then
		LFGListInviteDialog_Acknowledge(LFGListInviteDialog);
	end
end

local function UpdateFrames(name)
	local self = _G[DB.SELF];
	if name and DB.PF[name] then
		local TAB = DB.PF[name];
		DB.AutoInv			= TAB[1];
		DB.AutoInvGroup		= TAB[2];
		DB.Pattern			= TAB[3]	or "dreadlord||dread infiltrator||dread||doomsayer||toy||игрушка||вестник";
		DB.PatternNo		= TAB[4]	or "camp||farm||not up";
		DB.TestMode			= TAB[5];
		DB.Throttled		= TAB[6]	or 5;
		DB.TimeAge			= TAB[7]	or 6;
		DB.CrossRealmMode	= TAB[8];
		DB.MinPlayers		= TAB[9]	or 0;
		DB.RoleTank			= TAB[10];
		DB.RoleHealer		= TAB[11];
		DB.RoleDPS			= TAB[12];
		print(string.format(l.PROFILELOADED,name));
	end
	self.AutoInv:SetChecked(DB.AutoInv);
	self.AutoInvGroup:SetChecked(DB.AutoInvGroup);
	self.PatternNo:SetText(DB.PatternNo);
	self.TimeAge:SetText(DB.TimeAge);
	self.Pattern:SetText(DB.Pattern);
	self.Throttled:SetValue(DB.Throttled);
	self.TestMode:SetChecked(DB.TestMode);
	self.CrossRealmMode:SetChecked(DB.CrossRealmMode);
	-- self.CrossRealmMode:Disable();
	self.MinPlayers:SetText(DB.MinPlayers);
	self.RoleTank:SetChecked(DB.RoleTank);
	self.RoleHealer:SetChecked(DB.RoleHealer);
	self.RoleDPS:SetChecked(DB.RoleDPS);
	if SmartGroupFinderDB.ShowTooltip then
		self.Help.Icon:SetAlpha(1);
	else
		self.Help.Icon:SetAlpha(.3);
	end
	
	local tank,heal,dd = GetAvailableRoles();
	if not tank then
		self.RoleTank.LockedIndicator:Show();
		self.RoleTank:Disable();
	end
	if not heal then
		self.RoleHealer.LockedIndicator:Show();
		self.RoleHealer:Disable();
	end
	if not dd then
		self.RoleDPS.LockedIndicator:Show();
		self.RoleDPS:Disable();
	end
end

local function PopupCreate()
	StaticPopupDialogs["EXAMPLE_HELLOWORLD"] = {
		text = "Profile",
		button1 = CREATE_NEW_COMPACT_UNIT_FRAME_PROFILE,
		button2 = DELETE,
		button3 = l.PROFILELOAD,
		OnAccept = function(self)
			ClearCursor();
			local text = self.editBox:GetText();
			DB.PF[text] = {DB.AutoInv,DB.AutoInvGroup,DB.Pattern,DB.PatternNo,DB.TestMode,DB.Throttled,DB.TimeAge,DB.CrossRealmMode,DB.MinPlayers,DB.RoleTank,DB.RoleHealer,DB.RoleDPS};
			print(string.format(l.PROFILESAVE,text));
		end,
		OnAlt = function(self)
			ClearCursor();
			local text = self.editBox:GetText();
			UpdateFrames(text);
		end,
		OnCancel = function(self)
			if IsShiftKeyDown() then
				ClearCursor();
				local text = self.editBox:GetText();
				DB.PF[text] = nil;
				print(string.format(l.PROFILEDELETE,text));
			else
				print(format(ORANGE_COLOR.."SGF: %s|r", l.WARNDELPROFILE));
			end
		end,
		timeout = 0,
		whileDead = 1,
		exclusive = 1,
		-- showAlert = 1,
		hideOnEscape = 1,
		hasEditBox = 1,
		maxLetters = 32,
		OnShow = function(self)
			local t = l.PROFILE;
			if next(DB.PF) then
				for i,v in pairs(DB.PF) do
					t = t..i.."\n"
				end
			else
				t = ORANGE_COLOR.."SGF: Not Profiles.";
			end
			self.text:SetJustifyH("LEFT");
			self.text:SetText(t);
			self.button1:Disable();
			self.button2:Disable();
			self.button3:Disable();
		end,
		OnHide = function(self)
			self.editBox:SetText("");
			self.text:SetJustifyH("CENTER");
		end,
		EditBoxOnEnterPressed = function(self)
			if ( self:GetParent().button1:IsEnabled() ) then
				self:GetParent():Hide();
			end
		end,
		EditBoxOnTextChanged = function (self)
			local parent = self:GetParent();
			local text = parent.editBox:GetText();
			if ( DB.PF[text] ) then
				parent.button1:Disable();
				parent.button2:Enable();
				parent.button3:Enable();
			else
				if strlenutf8(text) > 0 then
					parent.button1:Enable();
				else
					parent.button1:Disable();
				end
				parent.button2:Disable();
				parent.button3:Disable();
			end
		end,
		EditBoxOnEscapePressed = function(self)
			self:GetParent():Hide();
			ClearCursor();
		end
	};
end

function EVENT.VARIABLES_LOADED(self)
	self:UnregisterEvent("VARIABLES_LOADED");
	-- SmartGroupFinderDB = nil;
	SmartGroupFinderDB = SmartGroupFinderDB or {
		AutoInv = false,
		AutoInvGroup = true,
		Pattern = "dreadlord||dread infiltrator||dread||doomsayer||toy||игрушка||вестник",
		PatternNo = "camp||farm||not up",
		TestMode = true,
		Throttled = 5,
		TimeAge = 6,
		CrossRealmMode = false,
		PF = {
			["ml"]={true,true,"terr||doom||death||veng","camp||farm||not up",false,3,5,false,0,true,true,true},
			["toy"]={true,true,"dreadlord||dread infiltrator||dread||doomsayer||toy||игрушка||вестник","camp||farm||not up",false,3,5,false,0,true,true,true}
		};
		SELF = self:GetName();
		MinPlayers = 0,
		RoleTank = true,
		RoleHealer = true,
		RoleDPS = true,
		ButtonPoint = {"CENTER"},
		FramePoint = {"LEFT"},
		ShowTooltip = true,
	};
	DB = SmartGroupFinderDB;
	local locale = GetLocale();
	if locale and L[locale] then
		l = L[locale];
	else
		l = L["enGB"];
	end
	
	self.GroupCount:SetText("");
	self.Log:SetText(l.FINDSTOP);
	self.StartStop:SetText(SLASH_STOPWATCH_PARAM_PLAY1);
	self.Pattern.Tooltip = l.STRINGFIND;
	self.PatternNo.Tooltip = l.STRINGEXCLUDE;
	self.TimeAge.Tooltip = l.AGEMAKEGROUP;
	self.AutoInvGroup.Text:SetText(l.ONLYAUTOINV);
	self.AutoInv.Text:SetText(l.ACCEPTINV);
	self.TestMode.Text:SetText(l.TESTMODE);
	self.CrossRealmMode.Text:SetText(l.CROSSREALM);
	self.Throttled:SetObeyStepOnDrag(true);
	self.Throttled:SetValueStep(1);
	self.Throttled.Tooltip = l.REFRESHRATE;
	self.AutoInvGroup.Tooltip = l.AUTOINVGROUP;
	self.AutoInv.Tooltip = l.AUTOINV;
	self.TestMode.Tooltip = l.TESTMODETOOLTIP;
	self.MinPlayers.Tooltip = l.MINPLAYERS;
	self.CrossRealmMode.Tooltip = l.CROSSREALMMODE;
	self.Help.Tooltip = l.HELPTOOLTIP,
	self:SetPoint(unpack( DB.FramePoint ));
	GudSFGButton:SetPoint(unpack( DB.ButtonPoint ));
	GudSFGButton.Tooltip = l.GUDSFGBUTTONTOOLTIP;
	UpdateFrames();
	PopupCreate();
end

function EVENT.PLAYER_ENTERING_WORLD(self)
	self:UnregisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("LFG_LIST_SEARCH_RESULTS_RECEIVED");
	self:RegisterEvent("LFG_LIST_SEARCH_RESULT_UPDATED");
	self:RegisterEvent("LFG_LIST_APPLICATION_STATUS_UPDATED");
	self:RegisterEvent("LFG_LIST_SEARCH_FAILED");
	self:RegisterEvent("LFG_LIST_JOINED_GROUP");
end

function SGFButtonUpdate(self,elapsed)
	local self = _G[SmartGroupFinderDB.SELF];
	if not self.run and self.pTime and (self.pTime > GetTime()) then
		self.StartStop:Disable();
		self.StartStop:SetText(ON_COOLDOWN);
		self.StartStop:SetBackdropColor(.2,.2,.2);
		GudSFGButton:Disable();
		GudSFGButton.Eye:Hide();
		return;
	else
		self.StartStop:Enable();
		GudSFGButton:Enable();
	end
	if IsInGroup() then
		self.StartStop:SetBackdropColor(1,1,0);
		self.StartStop:SetText(PARTY_LEAVE);
		return
	end
	if self.run then
		GudSFGButton.Eye:Show();
		self.StartStop:SetBackdropColor(1,.2,.2);
		self.StartStop:SetText(SLASH_STOPWATCH_PARAM_STOP1);
	else
		GudSFGButton.Eye:Hide();
		self.StartStop:SetBackdropColor(0,1,0);
		self.StartStop:SetText(LFG_LIST_SEARCH_AGAIN);
	end
end

function SGFButtonStart(self,button)
	if button == "LeftButton" then
		PlaySound("igMainMenuOptionCheckBoxOn");
		if IsInGroup() then
			LeaveParty();
			return;
		end
		local self = _G[SmartGroupFinderDB.SELF];
		if self.run then
			self.run = not self.run;
			return
		end
		if self.pTime and (self.pTime > GetTime()) then return; end
		self.run = not self.run;
		if self.run then
			SGFNewSearch(self);
		end
	elseif button == "RightButton" then
		local self = _G[SmartGroupFinderDB.SELF];
		if self:IsVisible() then
			self:Hide();
		else
			self:Show();
		end
	elseif button == "MiddleButton" then
		local _, dialog = StaticPopup_Visible("EXAMPLE_HELLOWORLD");
		if dialog then
			StaticPopup_Hide("EXAMPLE_HELLOWORLD");
		else
			StaticPopup_Show("EXAMPLE_HELLOWORLD");
		end
	end
	PlaySound("igMainMenuOptionCheckBoxOn");
end

SLASH_GUDPROFILESAVE1 = "/sgf"
SLASH_GUDPROFILESAVE1 = "/SGF"
SlashCmdList.GUDPROFILESAVE = function(msg)
	local com = gsub(msg, "%s*([^%s]+).*", "%1");
	local name = gsub(msg, "%s*([^%s]+)%s*(.*)", "%2");
	if com == "list" then
		if next(DB.PF) then
			for i,v in pairs(DB.PF) do
				print(ORANGE_COLOR.."SGF: --- --- ---|r");
				print(ORANGE_COLOR.."SGF: Profile: "..YELLOW_COLOR.."" .. i .."|r");
				print(ORANGE_COLOR.."SGF: Keywords: "..YELLOW_COLOR.."" .. v[3].."|r");
			end
		else
			print(ORANGE_COLOR.."SGF: Not Profiles.");
		end
		return;
	end
	if name ~= "" and com ~= "" then
		if com == "sp" then
			DB.PF[name] = {DB.AutoInv,DB.AutoInvGroup,DB.Pattern,DB.PatternNo,DB.TestMode,DB.Throttled,DB.TimeAge,DB.CrossRealmMode,DB.MinPlayers,DB.RoleTank,DB.RoleHealer,DB.RoleDPS};
			print(ORANGE_COLOR.."SGF: Save Profile: |r",name);
		elseif com == "dp" then
			if DB.PF[name] then
				DB.PF[name] = nil;
				print(ORANGE_COLOR.."SGF: Delete Profile: |r",name);
			end
		elseif com == "lp" then
			UpdateFrames(name);
		end
	end
end